.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comdlg32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
StaticClass db      'STATIC',0
hStatic     dd          ?
hStatic2    dd          ?
hBmp        dd          ?
lpBits      dd      32*32 dup(0ff00ffh)    
ps          PAINTSTRUCT     <>   
hbr         HBRUSH      ? 
pts         POINT       <16,0>
            POINT       <32,0>
            POINT       <32,32>
            POINT       <0,32>
            POINT       <0,16>
            POINT       <16,16>  
hRgn        HRGN        ? 
hRgnOld     HRGN        ?
cc      CHOOSECOLOR     <sizeof cc,?,?,0ffh,offset CustColors,CC_FULLOPEN+CC_RGBINIT,\
                        0,0,0>
CustColors  dd          040h,080h,0c0h,0ffh
            dd          4000h,8000h,0c000h,0ff00h
            dd          400000h,80000h,0c00000h,0ff0000h
            dd          40000000h,80000000h,0c0000000h,0ff000000h
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   hDC:DWORD
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
			invoke   InitCommonControls
                  invoke    CreateWindowEx,WS_EX_CLIENTEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_BITMAP+SS_NOTIFY,\
                                0,0,32,32,hWnd,10,hInstance,NULL  
                  mov     hStatic,eax           
                  invoke    CreateWindowEx,NULL,addr  StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_BITMAP+SS_NOTIFY,\
                                16,16,32,32,hWnd,20,hInstance,NULL
                mov     hStatic2,eax
                push        hWnd
                pop         cc.hwndOwner
                push    hInstance
                pop     cc.hInstance
  		.endif	        	
 ;     .elseif uMsg==WM_PAINT
 ;         invoke  BeginPaint,hStatic,addr ps
 ;         invoke  CreateSolidBrush,cc.rgbResult
 ;         mov     hbr,eax
 ;         invoke  SelectObject,ps.hdc,eax
 ;         invoke  DeleteObject,eax
 ;         invoke  FillRect,ps.hdc,addr ps.rcPaint,hbr
 ;         invoke  DeleteObject,hbr
 ;         invoke  EndPaint,hStatic,addr ps
 ;         
 ;         invoke  BeginPaint,hStatic2,addr ps
 ;         invoke  CreatePolygonRgn,addr pts,6,ALTERNATE
 ;         mov     hRgn,eax
 ;         invoke  SelectObject,ps.hdc,eax
 ;         invoke  DeleteObject,eax
 ;         invoke  CreateSolidBrush,0ff00h
 ;         mov     hbr,eax
 ;         invoke  SelectObject,ps.hdc,eax
 ;         invoke  DeleteObject,eax
 ;         invoke  FillRgn,ps.hdc,hRgn,hbr
 ;         invoke  DeleteObject,hbr
 ;         invoke  DeleteObject,hRgn
 ;         invoke  EndPaint,hStatic2,addr
        
    .elseif     uMsg==WM_COMMAND
        mov     eax,wParam
        ror     eax,16
        .if     ax==STN_CLICKED
            rol     eax,16
            .if     ax==10
                invoke  Beep,200,20
                invoke  SetFocus,hWnd                
                invoke  ChooseColor,addr cc

            .elseif ax==20
                invoke  Beep,400,20
            .endif                                
        .elseif ax==STN_DBLCLK
            rol     eax,16
            .if     ax==20
                invoke  Beep,600,20
            .endif
        .endif                                        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end	start